// File: Dreieck.h

#ifndef Dreieck_h
#define Dreieck_h 1

#include <GeoObj.h>
#include <PunktV.h>

class Dreieck : public GeoObj  
{
private:  
  Punkt EckPunkt[3];

protected:
  virtual int CompareTo(const GeoObj*) const;
  virtual void WriteOn(ostream&) const;
  virtual void ReadFrom(istream&);

public:
  Dreieck(const Punkt& = Punkt(.0, .0),
          const Punkt& = Punkt(.0, .0),
          const Punkt& = Punkt(.0, .0));
  Dreieck(const Dreieck &right);

  const Dreieck & operator=(const Dreieck &right);

  const Punkt get_EckPunkt(const int index) const;
  void set_EckPunkt(const int index, const Punkt value);

  virtual GeoObj* Clone() const;
  virtual float flaeche() const;
  virtual String GetTypeString() const;
};

inline const Punkt Dreieck::get_EckPunkt(const int index) const
{
  return EckPunkt[index];
}

inline void Dreieck::set_EckPunkt(const int index, const Punkt value)
{
  EckPunkt[index] = value;
}

#endif
