// File: DreieckV.cc

#include <math.h>
#include <DreieckV.h>

Dreieck::Dreieck(const Punkt& p0, const Punkt& p1, const Punkt& p2)
{
  EckPunkt[0] = p0;
  EckPunkt[1] = p1;
  EckPunkt[2] = p2;
}

Dreieck::Dreieck(const Dreieck &right)
{
  EckPunkt[0] = right.EckPunkt[0];
  EckPunkt[1] = right.EckPunkt[1];
  EckPunkt[2] = right.EckPunkt[2];
}

const Dreieck & Dreieck::operator=(const Dreieck &right)
{
  if(this != &right)
  {
    EckPunkt[0] = right.EckPunkt[0];
    EckPunkt[1] = right.EckPunkt[1];
    EckPunkt[2] = right.EckPunkt[2];
  }
  return *this;
}

float Dreieck::flaeche() const
{
  return (fabs(EckPunkt[0].x*(EckPunkt[1].y-EckPunkt[2].y)
             + EckPunkt[1].x*(EckPunkt[2].y-EckPunkt[0].y)
             + EckPunkt[2].x*(EckPunkt[0].y-EckPunkt[1].y)) / 2.0);
}
