// File: Kreis.cc

#include <Kreis.h>

const float Kreis::PI = 3.14159265389;

Kreis::Kreis(const Punkt& _MittelPunkt, float _Radius)
: MittelPunkt(_MittelPunkt), Radius(_Radius){}

Kreis::Kreis(const Kreis &right)
:  GeoObj(right), MittelPunkt(right.MittelPunkt), Radius(right.Radius){}

const Kreis & Kreis::operator=(const Kreis &right)
{
  if(this != &right)
  {
    GeoObj::operator=(right);
    MittelPunkt = right.MittelPunkt;
    Radius = right.Radius;
  }
  return *this;
}

GeoObj* Kreis::Clone() const
{
  return new Kreis(*this);
}

float Kreis::flaeche() const
{
  return (Radius * Radius * PI);
}

int Kreis::CompareTo(const GeoObj* right) const
{
  if(right->GetTypeString() == GetTypeString())
  {
    const Kreis* pr = (const Kreis*)right;
    return ((MittelPunkt == pr->MittelPunkt)
              && (Radius == pr->Radius));
  }
  else
    return 0;

}

void Kreis::WriteOn(ostream& ros) const
{
  ros << " " << MittelPunkt
      << " " << Radius;
}

void Kreis::ReadFrom(istream& ris)
{
  ris >> MittelPunkt
      >> Radius;
}

String Kreis::GetTypeString() const
{
  return "[Kreis]";
}
