// File: RchteckN.cc

#include <math.h>
#include <PROTECT/RchteckN.h>

Rechteck::Rechteck(const Punkt& p0, const Punkt& p1)
{
  EckPunkt[0] = p0;
  EckPunkt[1] = p1;
}

Rechteck::Rechteck(const Rechteck &right)
{
  EckPunkt[0] = right.EckPunkt[0];
  EckPunkt[1] = right.EckPunkt[1];
}

const Rechteck& Rechteck::operator=(const Rechteck &right)
{
   if(this != &right)
   { 
     EckPunkt[0] = right.EckPunkt[0];
     EckPunkt[1] = right.EckPunkt[1];
   }

   return *this;
}

float Rechteck::flaeche() const
{
  return fabs((EckPunkt[0].x - EckPunkt[1].x) * (EckPunkt[0].y - EckPunkt[1].y));
}

int Rechteck::CompareTo(const GeoObj* right) const
{
  if(right->GetTypeString() == GetTypeString())
  {
    const Rechteck* pr = (const Rechteck*)right;
    return ((EckPunkt[0] == pr->EckPunkt[0])
         && (EckPunkt[1] == pr->EckPunkt[1]));
  }
  else
    return 0;
}

String Rechteck::GetTypeString() const
{
  return "[Rechteck]";
}
